;TunInc.asm  by Robert Rayment

;VB
;res& = CallWindowProc(ptmc&, ptbuff&, 2&, 3&, 4&)
;                             8        12  16  20
;Fill BITDATA structure
;Private Type BITDATA
; bmp.bmWidth = 256          'Pixel width
; bmp.bmHeight = 256         'Pixel height
; bmp.ptrDrawSurf = VarPtr(DrawSurf(257)) 'Pointer to drawing surface
; bmp.ptrRendSurf = VarPtr(RendSurf(1))   ' Pointer to rendering surface
;Dim bmp As BITDATA

%macro movab 2		;name & num of parameters
  push dword %2		;2nd param
  pop dword %1		;1st param
%endmacro			;use  movab %1,%2
;Allows eg	movab bmW,[ebx+4]

%define bmW   [ebp-4]	;eg 300
%define bmH   [ebp-8]	;eg 300
%define bmDS  [ebp-12]	;pointer to Draw Surface
%define bmRS  [ebp-16]	;pointer to Render Surface

%define lo32 [ebp-20]
%define hi32 [ebp-24]

%define irand [ebp-28]	;random number 0-255

;%define ix    [ebp-20]
;%define iy    [ebp-24]
;%define cul   [ebp-28]
;%define rads  [ebp-32]
;%define xcen  [ebp-36]
;%define ycen  [ebp-40]

[bits 32]

	push ebp
	mov ebp,esp
	sub esp,28
	push edi
	push esi
	push ebx

	;Fill bmp structure
	mov ebx,[ebp+8]
	movab bmW,[ebx]
	movab bmH,[ebx+4]
	movab bmDS,[ebx+8]
	movab bmRS,[ebx+12]
	

	;mov eax,bmW			
	;shr eax,1
	;mov xcen,eax
	
	;mov eax,bmH			
	;shr eax,1
	;mov ycen,eax
	
	mov eax,[ebp+20]	;Get Type	1,2,4,8,16,
	rcr eax,1
	jnc TestType2

	CALL MMXDec
	jmp GETOUT

TestType2:
	rcr eax,1
	jnc TestType4

	CALL MMXDec
	CALL AvDrawSurface
	jmp GETOUT

TestType4:
	rcr eax,1
	jnc TestType8

	CALL MMXUpScroller
	jmp GETOUT


TestType8:

	rcr eax,1
	jnc TestType16

	CALL MMXDnScroller
	jmp GETOUT
	
TestType16:

	rcr eax,1
	jnc TestType32

	CALL MMXLeftScroller
	jmp GETOUT

TestType32:
	rcr eax,1
	jnc TestType64

	CALL MMXRightScroller
	jmp GETOUT
	
TestType64:
	rcr eax,1
	jnc TestType128
	
;------------------------------------------------------------
	in al,040h          ;Seed from timer
	mov irand,eax
;------------------------------------------------------------

	CALL FIRE
	jmp GETOUT
	
TestType128:

GETOUT:

	pop ebx
	pop esi
	pop edi
	mov esp,ebp
	pop ebp
	ret 16

;--- Retrace  Slows things down
;--- No good because only small
;--- part of the total screen update
;--- Also  mov dx,03DAh in NT doubtful.

;mov   dx,03DAh    ;Status register 
;WaitForOFF:      
;in    al,dx     
;test  al,8	  ;Is scan OFF
;jnz   WaitForOFF  ;No, keep waiting

;WaitForON:
;in    al,dx     
;test  al,8	  ;Is scan ON
;jz    WaitForON	  ;No, keep waiting


;############################################################
;	CPU DECREMENT COLOR NUMBER EVERWHERE ON DRAW SURFACE
;	TUNNEL EFFECT	NOT USED
DecrementColor:
	mov edi,bmDS	;->Draw surface
	mov ebx,bmH
	sub edi,ebx
	inc ebx			;ie 258 lines
	inc ebx			;ie 258 lines
LOOPY:
	mov ecx,bmW
LOOPX:
	dec Byte[edi]
	inc edi
	dec ecx
	jnz LOOPX
	
	dec ebx
	jnz LOOPY
ret


;############################################################
;	MMX DECREMENT COLOR NUMBER EVERWHERE ON DRAW SURFACE
;	TUNNEL EFFECT
MMXDec:
	mov edi,bmDS	;->Draw surface Line 2
	
	mov edx,bmH		;Number of lines
	sub edi,edx		;->Line 1
	inc edx			;ie 257 lines
	inc edx			;ie 258 lines
	
	mov eax,01010101h	;Make 8 bytes
	mov lo32,eax		;to sub 1 from each byte
	mov hi32,eax
	movq mm1,hi32

	mov ebx,8
	
	mov eax,32
	mul edx	;32*258
LMMXY:
	movq mm0,[edi]
	psubb mm0,mm1		;sub 8 bytes at a time
	movq [edi],mm0		;with overlap ie 0->255
	
	add edi,ebx
	
	dec eax
	jnz LMMXY
	emms			;Clear FP/MMX stack
ret

;############################################################
;	AVERAGE DRAW SURFACE - BOILING BUBBLES
AvDrawSurface:
	mov edi,bmDS	;->Draw Surface
	mov edx,bmH
AVERY:
	mov ecx,bmW
AVERX:
	movzx bx,Byte[edi+1]	;byte to ebx & zero extend
	movzx ax,Byte[edi-256]	;Assumes bmW=256!
	add bx,ax
	mov al,Byte[edi-1]
	add bx,ax
	mov al,Byte[edi+256]	;Assumes bmW=256!
	add bx,ax
	shr bx,2				;/4
	mov [edi],bl			;Store average value

	inc edi
	dec ecx
	jnz AVERX
	
	dec edx
	jnz AVERY
ret
;############################################################

;	AVERAGE DRAW SURFACE TO RENDER SURFACE NOT USED
RendSurface:
	mov esi,bmDS	;->Draw Surface
	mov edi,bmRS	;->RenderSurface
	mov edx,bmH
RENDY:
	mov ecx,bmW
RENDX:
	movzx bx,Byte[esi+1]	;byte to ebx & zero extend
	movzx ax,Byte[esi-256]	;Assumes bmW=256!
	add bx,ax
	mov al,Byte[esi-1]
	add bx,ax
	mov al,Byte[esi+256]	;Assumes bmW=256!
	add bx,ax
	shr bx,2				;/4
	mov [edi],bl			;Store average value
	inc esi
	inc edi
	dec ecx
	jnz RENDX
	
	dec edx
	jnz RENDY
ret

;############################################################

;	MMX UP SCROLLER

MMXUpScroller:
	mov edi,bmDS	;->Draw surface line 2
	mov eax,65536	;256*256
	add edi,eax		;-> top line 258
	push edi		;Save pointer
	mov esi,edi 	
	mov eax,256
	sub esi,eax		;->Line257
	
	;Move 256 lines up
	mov ebx,8		;8 64-bit mmx regs = 256 bytes
	mov ecx,256		;Number of lines = 256
UPMOVER:
	push esi
	push edi
	mov eax,32
MOVE1LINEUP:
	movq mm0,[esi]	;   Line 257, 256,, 2,1
	movq [edi],mm0	;to Line 258, 257,, 3,2
	add esi,ebx
	add edi,ebx
	dec eax
	jnz MOVE1LINEUP
	
	pop edi
	pop esi
	mov eax,256
	sub esi,eax
	sub edi,eax
	dec ecx
	jnz UPMOVER
	
	;edi->line 2
	
	;Move Line 258 to Line 2
	pop esi		;-> Line 258
	mov ecx,32
Top2Bottom:
	movq mm0,[esi]
	movq [edi],mm0
	add esi,ebx
	add edi,ebx
	dec ecx
	jnz Top2Bottom
	emms			;Clear FP/MMX stack
ret

;############################################################

;	MMX DOWN SCROLLER

MMXDnScroller:
	mov esi,bmDS	;->Draw surface line 2
	mov edi,esi 	
	mov eax,256
	sub edi,eax		;->Line1
	push edi		;save pointer to Line 1
	
	;Move 256 lines down
	mov ebx,8		;8 64-bit mmx regs = 256 bytes
	mov ecx,256		;Number of lines = 256
DNMOVER:
	mov eax,32
MOVE1LINEDN:
	movq mm0,[esi]	;   Line 2, 3,, 257
	movq [edi],mm0	;to Line 1, 2,, 256
	add esi,ebx
	add edi,ebx
	dec eax
	jnz MOVE1LINEDN
	
	dec ecx
	jnz DNMOVER
	
	;edi->line 257
	
	;Move Line 1 to Line 257
	pop esi		;-> Line 1
	mov ecx,32
Bottom2Top:
	movq mm0,[esi]
	movq [edi],mm0
	add esi,ebx
	add edi,ebx
	dec ecx
	jnz Bottom2Top
	emms			;Clear FP/MMX stack
ret

;############################################################

;	MMX LEFT SCROLLER

MMXLeftScroller:
	mov edi,bmDS	;->Draw surface line 2
	
	;Shift 256 lines left
	mov ebx,8		;8 64-bit mmx regs = 256 bytes
	mov ecx,256		;Number of lines = 256
LEMOVER:
	mov dl,[edi]	;left byte
	inc edi
	mov eax,32
MOVE1LINELE:
	movq mm0,[edi]	;pick up 8 bytes
	dec edi
	movq [edi],mm0	;place 8 bytes 1 byte to left
	inc edi
	add edi,ebx
	dec eax
	jnz MOVE1LINELE
	
	dec edi
	dec edi
	mov [edi],dl
	inc edi
	dec ecx
	jnz LEMOVER
	emms			;Clear FP/MMX stack
ret

;############################################################

;	MMX RIGHT SCROLLER

MMXRightScroller:
	mov edi,bmDS	;->Draw surface line 2
	mov eax,65536	;256*256
	add edi,eax		;-> top line 258
	dec edi			;-> end line 257
	
	;Shift 256 lines right
	mov ebx,8		;8 64-bit mmx regs = 256 bytes
	mov ecx,256		;Number of lines = 256
RIMOVER:
	mov dl,[edi]	;right byte
	sub edi,ebx		;back 8 bytes
	mov eax,32
MOVE1LINERI:
	movq mm0,[edi]	;pick up 8 bytes
	inc edi
	movq [edi],mm0	;place 8 bytes 1 byte to right
	dec edi
	sub edi,ebx
	dec eax
	jnz MOVE1LINERI
	
	add edi,ebx
	inc edi
	mov [edi],dl
	dec edi
	dec ecx
	jnz RIMOVER
	emms			;Clear FP/MMX stack
ret

;############################################################

;	FIRE
FIRE:

	mov edi,bmDS	;->Draw surface line 2
	mov eax,256
	add edi,eax		;->Line 3

	mov eax,240		;Do 240 lines then into black
	mov ebx,256
	mul ebx
	mov ecx,eax		;Total number of cells used

	;Pick up colors from below & move them up
	;Very subtle this, small changes make huge
	;changes to display. Also the palette is
	;very critical

MigrateUP:
  	xor dx,dx             ;Sum up 4 colors
 	
  	mov dl,[edi-257]      ;Line 2, below left
  	mov ax,dx             ;ax = dx
  	mov dl,[edi-256]      ;Line 2, below
  	add ax,dx             ;sum
  	mov dl,[edi-255]      ;Line 2, below right
  	add ax,dx             ;sum
  	mov dl,[edi-512]      ;Line 1, below
  	add ax,dx             ;sum
  	shr ax,2              ;/4 average
  
  	jz StoreCul           ;ax=0 color num?
  	dec ax                ;no move towards 0 ie black
StoreCul:

  	mov [edi],al          ; put the new pixel value back in the array.
  	inc edi               ; go to the next one.
	dec ecx
	jnz MigrateUP

ret
